Index: src/hugo/array_map.h
===================================================================
--- src/hugo/array_map.h	(revision 897)
+++ src/hugo/array_map.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef ARRAY_MAP_H
-#define ARRAY_MAP_H
+#ifndef HUGO_ARRAY_MAP_H
+#define HUGO_ARRAY_MAP_H
 
 #include <memory>
@@ -332,3 +332,3 @@
 }
 
-#endif
+#endif //HUGO_ARRAY_MAP_H
Index: src/hugo/bin_heap.h
===================================================================
--- src/hugo/bin_heap.h	(revision 776)
+++ src/hugo/bin_heap.h	(revision 901)
@@ -245,3 +245,3 @@
 } // namespace hugo
 
-#endif // BIN_HEAP_HH
+#endif // HUGO_BIN_HEAP_H
Index: src/hugo/default_map.h
===================================================================
--- src/hugo/default_map.h	(revision 897)
+++ src/hugo/default_map.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef DEFAULT_MAP_H
-#define DEFAULT_MAP_H
+#ifndef HUGO_DEFAULT_MAP_H
+#define HUGO_DEFAULT_MAP_H
 
 
Index: src/hugo/extended_pair.h
===================================================================
--- src/hugo/extended_pair.h	(revision 897)
+++ src/hugo/extended_pair.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef EXTENDED_PAIR_H
-#define EXTENDED_PAIR_H
+#ifndef HUGO_EXTENDED_PAIR_H
+#define HUGO_EXTENDED_PAIR_H
 
 template <typename T1, typename A1, typename T2, typename A2>
Index: src/hugo/map_bits.h
===================================================================
--- src/hugo/map_bits.h	(revision 844)
+++ src/hugo/map_bits.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*- 
-#ifndef MAP_BITS_H
-#define MAP_BITS_H
+#ifndef HUGO_MAP_BITS_H
+#define HUGO_MAP_BITS_H
 
 ///\ingroup graphmaps
Index: src/hugo/map_defines.h
===================================================================
--- src/hugo/map_defines.h	(revision 897)
+++ src/hugo/map_defines.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef MAP_DEFINES_H
-#define MAP_DEFINES_H
+#ifndef HUGO_MAP_DEFINES_H
+#define HUGO_MAP_DEFINES_H
 
 ///\ingroup graphmaps
Index: src/hugo/map_iterator.h
===================================================================
--- src/hugo/map_iterator.h	(revision 844)
+++ src/hugo/map_iterator.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef MAP_ITERATOR_H
-#define MAP_ITERATOR_H
+#ifndef HUGO_MAP_ITERATOR_H
+#define HUGO_MAP_ITERATOR_H
 
 #include <iterator>
Index: src/hugo/map_registry.h
===================================================================
--- src/hugo/map_registry.h	(revision 891)
+++ src/hugo/map_registry.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef MAP_REGISTRY_H
-#define MAP_REGISTRY_H
+#ifndef HUGO_MAP_REGISTRY_H
+#define HUGO_MAP_REGISTRY_H
 
 #include <vector>
Index: src/hugo/min_cost_flow.h
===================================================================
--- src/hugo/min_cost_flow.h	(revision 899)
+++ src/hugo/min_cost_flow.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef HUGO_MINCOSTFLOWS_H
-#define HUGO_MINCOSTFLOWS_H
+#ifndef HUGO_MIN_COST_FLOW_H
+#define HUGO_MIN_COST_FLOW_H
 
 ///\ingroup flowalgs
@@ -239,3 +239,3 @@
 } //namespace hugo
 
-#endif //HUGO_MINCOSTFLOWS_H
+#endif //HUGO_MIN_COST_FLOW_H
Index: src/hugo/suurballe.h
===================================================================
--- src/hugo/suurballe.h	(revision 899)
+++ src/hugo/suurballe.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef HUGO_MINLENGTHPATHS_H
-#define HUGO_MINLENGTHPATHS_H
+#ifndef HUGO_SUURBALLE_H
+#define HUGO_SUURBALLE_H
 
 ///\ingroup flowalgs
@@ -198,3 +198,3 @@
 } //namespace hugo
 
-#endif //HUGO_MINLENGTHPATHS_H
+#endif //HUGO_SUURBALLE_H
Index: src/hugo/sym_map.h
===================================================================
--- src/hugo/sym_map.h	(revision 897)
+++ src/hugo/sym_map.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef SYM_MAP_H
-#define SYM_MAP_H
+#ifndef HUGO_SYM_MAP_H
+#define HUGO_SYM_MAP_H
 
 ///\ingroup graphmaps
Index: src/hugo/vector_map.h
===================================================================
--- src/hugo/vector_map.h	(revision 897)
+++ src/hugo/vector_map.h	(revision 901)
@@ -1,5 +1,5 @@
 // -*- c++ -*-
-#ifndef VECTOR_MAP_H
-#define VECTOR_MAP_H
+#ifndef HUGO_VECTOR_MAP_H
+#define HUGO_VECTOR_MAP_H
 
 #include <vector>
Index: src/work/marci/makefile
===================================================================
--- src/work/marci/makefile	(revision 864)
+++ src/work/marci/makefile	(revision 901)
@@ -5,5 +5,5 @@
 
 LEDABINARIES = leda_graph_demo leda_bfs_dfs max_bipartite_matching_demo
-BINARIES = sub_graph_wrapper_demo.cc graph_wrapper_time max_flow_demo iterator_bfs_demo macro_test lg_vs_sg_vs_sg bfsit_vs_byhand bipartite_graph_wrapper_test bipartite_matching_demo top_sort_test max_flow_1 proba7 proba8
+BINARIES = sub_graph_wrapper_demo.cc graph_wrapper_time max_flow_demo iterator_bfs_demo macro_test lg_vs_sg_vs_sg bfsit_vs_byhand bipartite_graph_wrapper_test bipartite_matching_demo top_sort_test max_flow_1 proba7 proba10
 #BINARIES = preflow_bug
 #gw_vs_not preflow_demo_boost edmonds_karp_demo_boost preflow_demo_jacint preflow_demo_athos edmonds_karp_demo_alpar preflow_demo_leda