Index: src/work/athos/pf_demo.cc
===================================================================
--- src/work/athos/pf_demo.cc	(revision 36)
+++ src/work/athos/pf_demo.cc	(revision 77)
@@ -3,7 +3,7 @@
 #include <string>
 
-#include "marci_list_graph.hh"
+#include "list_graph.hh"
 #include "marci_graph_traits.hh"
-#include "marci_property_vector.hh"
+//#include "marci_property_vector.hh"
 #include "preflow_push.hh"
 
@@ -13,22 +13,65 @@
 int main (int, char*[])
 {
-  typedef graph_traits<list_graph>::node_iterator node_iterator;
-  typedef graph_traits<list_graph>::edge_iterator edge_iterator;
-  typedef graph_traits<list_graph>::each_node_iterator each_node_iterator;
-  typedef graph_traits<list_graph>::each_edge_iterator each_edge_iterator;
-  typedef graph_traits<list_graph>::out_edge_iterator out_edge_iterator;
-  typedef graph_traits<list_graph>::in_edge_iterator in_edge_iterator;
-  typedef graph_traits<list_graph>::sym_edge_iterator sym_edge_iterator;
 
-  list_graph flow_test;
- 
   
+  typedef ListGraph::NodeIt NodeIt;
+  typedef ListGraph::EdgeIt EdgeIt;
+  /*
+  typedef ListGraph::EachNodeIt EachNodeIt;
+  typedef ListGraph::EachEdgeIt EachEdgeIt;
+  typedef ListGraph::OutEdgeIt OutEdgeIt;
+  typedef ListGraph::InEdgeIt InEdgeIt;
+  typedef ListGraph::SymEdgeIt SymEdgeIt;
+  */
+  
+  //Marci példája
+  ListGraph flowG;
+
+  NodeIt s=flowG.addNode();
+  NodeIt v1=flowG.addNode();
+  NodeIt v2=flowG.addNode();
+  NodeIt v3=flowG.addNode();
+  NodeIt v4=flowG.addNode();
+  NodeIt t=flowG.addNode();
+  
+
+  EdgeIt s_v1=flowG.addEdge(s, v1);
+  EdgeIt s_v2=flowG.addEdge(s, v2);
+  EdgeIt v1_v2=flowG.addEdge(v1, v2);
+  EdgeIt v2_v1=flowG.addEdge(v2, v1);
+  EdgeIt v1_v3=flowG.addEdge(v1, v3);
+  EdgeIt v3_v2=flowG.addEdge(v3, v2);
+  EdgeIt v2_v4=flowG.addEdge(v2, v4);
+  EdgeIt v4_v3=flowG.addEdge(v4, v3);
+  EdgeIt v3_t=flowG.addEdge(v3, t);
+  EdgeIt v4_t=flowG.addEdge(v4, t);
+
+  ListGraph::EdgeMap<int> cap(flowG);
+
+  cap.set(s_v1, 16);
+  cap.set(s_v2, 13);
+  cap.set(v1_v2, 10);
+  cap.set(v2_v1, 4);
+  cap.set(v1_v3, 12);
+  cap.set(v3_v2, 9);
+  cap.set(v2_v4, 14);
+  cap.set(v4_v3, 7);
+  cap.set(v3_t, 20);
+  cap.set(v4_t, 4);
+
+
+
+
+
+
+
+  /*
   //Ahuja könyv példája
   node_iterator s=flow_test.add_node();
-  node_iterator v2=flow_test.add_node();
-  node_iterator v3=flow_test.add_node();
-  node_iterator v4=flow_test.add_node();
-  node_iterator v5=flow_test.add_node();
-  node_iterator t=flow_test.add_node();
+  NodeIt v2=flow_test.add_node();
+  NodeIt v3=flow_test.add_node();
+  NodeIt v4=flow_test.add_node();
+  NodeIt v5=flow_test.add_node();
+  NodeIt t=flow_test.add_node();
   
   node_property_vector<list_graph, std::string> node_name(flow_test);
@@ -71,50 +114,13 @@
   //cap.put(t_s, 20);
 
-  
-  /*
-  //Marci példája
-  node_iterator s=flow_test.add_node();
-  node_iterator v1=flow_test.add_node();
-  node_iterator v2=flow_test.add_node();
-  node_iterator v3=flow_test.add_node();
-  node_iterator v4=flow_test.add_node();
-  node_iterator t=flow_test.add_node();
-  
-  node_property_vector<list_graph, std::string> node_name(flow_test);
-  node_name.put(s, "s");
-  node_name.put(v1, "v1");
-  node_name.put(v2, "v2");
-  node_name.put(v3, "v3");
-  node_name.put(v4, "v4");
-  node_name.put(t, "t");
+  */
 
-  edge_iterator s_v1=flow_test.add_edge(s, v1);
-  edge_iterator s_v2=flow_test.add_edge(s, v2);
-  edge_iterator v1_v2=flow_test.add_edge(v1, v2);
-  edge_iterator v2_v1=flow_test.add_edge(v2, v1);
-  edge_iterator v1_v3=flow_test.add_edge(v1, v3);
-  edge_iterator v3_v2=flow_test.add_edge(v3, v2);
-  edge_iterator v2_v4=flow_test.add_edge(v2, v4);
-  edge_iterator v4_v3=flow_test.add_edge(v4, v3);
-  edge_iterator v3_t=flow_test.add_edge(v3, t);
-  edge_iterator v4_t=flow_test.add_edge(v4, t);
-  
-  edge_property_vector<list_graph, int> cap(flow_test);  
-  cap.put(s_v1, 16);
-  cap.put(s_v2, 13);
-  cap.put(v1_v2, 10);
-  cap.put(v2_v1, 4);
-  cap.put(v1_v3, 12);
-  cap.put(v3_v2, 9);
-  cap.put(v2_v4, 14);
-  cap.put(v4_v3, 7);
-  cap.put(v3_t, 20);
-  cap.put(v4_t, 4);
-  */ 
+
+
   /*Egyszerû példa
-  node_iterator s=flow_test.add_node();
-  node_iterator v1=flow_test.add_node();
-  node_iterator v2=flow_test.add_node();
-  node_iterator t=flow_test.add_node();
+  NodeIt s=flow_test.add_node();
+  NodeIt v1=flow_test.add_node();
+  NodeIt v2=flow_test.add_node();
+  NodeIt t=flow_test.add_node();
   
   node_property_vector<list_graph, std::string> node_name(flow_test);
@@ -136,7 +142,9 @@
 
   std::cout << "preflow-push algorithm test..." << std::endl;
+
+  /*
   std::cout << "on directed graph graph" << std::endl; //<< flow_test;
   std::cout << "names and capacity values" << std::endl; 
-  for(each_node_iterator i=flow_test.first_node(); i.valid(); ++i) { 
+  for(EachNodeIt i=flow_test.first_node(); i.valid(); ++i) { 
     std::cout << node_name.get(i) << ": ";
     std::cout << "out edges: ";
@@ -148,11 +156,11 @@
     std::cout << std::endl;
   }
-
+  */
   
-  //for(each_node_iterator i=flow_test.first_node(); i.valid(); ++i) { 
+  //for(each_NodeIt i=flow_test.first_node(); i.valid(); ++i) { 
   //  std::cout << i << " ";
   //}
   
-  preflow_push<list_graph, int> preflow_push_test(flow_test, s, t, cap);
+  preflow_push<ListGraph, int> preflow_push_test(flowG, s, t, cap);
   cout << preflow_push_test.run()<<endl;
 